// Code generated by SQLBoiler 4.6.0 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/randomize"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testVisits(t *testing.T) {
	t.Parallel()

	query := Visits()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testVisitsDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testVisitsQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := Visits().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testVisitsSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := VisitSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testVisitsExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := VisitExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if Visit exists: %s", err)
	}
	if !e {
		t.Errorf("Expected VisitExists to return true, but got false.")
	}
}

func testVisitsFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	visitFound, err := FindVisit(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if visitFound == nil {
		t.Error("want a record, got nil")
	}
}

func testVisitsBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = Visits().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testVisitsOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := Visits().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testVisitsAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	visitOne := &Visit{}
	visitTwo := &Visit{}
	if err = randomize.Struct(seed, visitOne, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err = randomize.Struct(seed, visitTwo, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = visitOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = visitTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Visits().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testVisitsCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	visitOne := &Visit{}
	visitTwo := &Visit{}
	if err = randomize.Struct(seed, visitOne, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err = randomize.Struct(seed, visitTwo, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = visitOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = visitTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func visitBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func visitAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Visit) error {
	*o = Visit{}
	return nil
}

func testVisitsHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &Visit{}
	o := &Visit{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, visitDBTypes, false); err != nil {
		t.Errorf("Unable to randomize Visit object: %s", err)
	}

	AddVisitHook(boil.BeforeInsertHook, visitBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	visitBeforeInsertHooks = []VisitHook{}

	AddVisitHook(boil.AfterInsertHook, visitAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	visitAfterInsertHooks = []VisitHook{}

	AddVisitHook(boil.AfterSelectHook, visitAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	visitAfterSelectHooks = []VisitHook{}

	AddVisitHook(boil.BeforeUpdateHook, visitBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	visitBeforeUpdateHooks = []VisitHook{}

	AddVisitHook(boil.AfterUpdateHook, visitAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	visitAfterUpdateHooks = []VisitHook{}

	AddVisitHook(boil.BeforeDeleteHook, visitBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	visitBeforeDeleteHooks = []VisitHook{}

	AddVisitHook(boil.AfterDeleteHook, visitAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	visitAfterDeleteHooks = []VisitHook{}

	AddVisitHook(boil.BeforeUpsertHook, visitBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	visitBeforeUpsertHooks = []VisitHook{}

	AddVisitHook(boil.AfterUpsertHook, visitAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	visitAfterUpsertHooks = []VisitHook{}
}

func testVisitsInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testVisitsInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(visitColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testVisitToOneAgentVersionUsingAgentVersion(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign AgentVersion

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, agentVersionDBTypes, false, agentVersionColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize AgentVersion struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&local.AgentVersionID, foreign.ID)
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.AgentVersion().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if !queries.Equal(check.ID, foreign.ID) {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadAgentVersion(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.AgentVersion == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.AgentVersion = nil
	if err = local.L.LoadAgentVersion(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.AgentVersion == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOneCrawlUsingCrawl(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign Crawl

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, crawlDBTypes, false, crawlColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Crawl struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&local.CrawlID, foreign.ID)
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Crawl().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if !queries.Equal(check.ID, foreign.ID) {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadCrawl(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Crawl == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Crawl = nil
	if err = local.L.LoadCrawl(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Crawl == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOneMultiAddressesSetUsingMultiAddressesSet(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign MultiAddressesSet

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, multiAddressesSetDBTypes, false, multiAddressesSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize MultiAddressesSet struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&local.MultiAddressesSetID, foreign.ID)
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.MultiAddressesSet().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if !queries.Equal(check.ID, foreign.ID) {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadMultiAddressesSet(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.MultiAddressesSet == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.MultiAddressesSet = nil
	if err = local.L.LoadMultiAddressesSet(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.MultiAddressesSet == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOnePeerUsingPeer(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign Peer

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, peerDBTypes, false, peerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Peer struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.PeerID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Peer().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadPeer(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Peer == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Peer = nil
	if err = local.L.LoadPeer(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Peer == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOneProtocolsSetUsingProtocolsSet(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign ProtocolsSet

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, protocolsSetDBTypes, false, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&local.ProtocolsSetID, foreign.ID)
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.ProtocolsSet().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if !queries.Equal(check.ID, foreign.ID) {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadProtocolsSet(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.ProtocolsSet == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.ProtocolsSet = nil
	if err = local.L.LoadProtocolsSet(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.ProtocolsSet == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOneSessionUsingSession(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Visit
	var foreign Session

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, sessionDBTypes, false, sessionColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Session struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&local.SessionID, foreign.ID)
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Session().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if !queries.Equal(check.ID, foreign.ID) {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := VisitSlice{&local}
	if err = local.L.LoadSession(ctx, tx, false, (*[]*Visit)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Session == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Session = nil
	if err = local.L.LoadSession(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Session == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testVisitToOneSetOpAgentVersionUsingAgentVersion(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c AgentVersion

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, agentVersionDBTypes, false, strmangle.SetComplement(agentVersionPrimaryKeyColumns, agentVersionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, agentVersionDBTypes, false, strmangle.SetComplement(agentVersionPrimaryKeyColumns, agentVersionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*AgentVersion{&b, &c} {
		err = a.SetAgentVersion(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.AgentVersion != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if !queries.Equal(a.AgentVersionID, x.ID) {
			t.Error("foreign key was wrong value", a.AgentVersionID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.AgentVersionID))
		reflect.Indirect(reflect.ValueOf(&a.AgentVersionID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if !queries.Equal(a.AgentVersionID, x.ID) {
			t.Error("foreign key was wrong value", a.AgentVersionID, x.ID)
		}
	}
}

func testVisitToOneRemoveOpAgentVersionUsingAgentVersion(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b AgentVersion

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, agentVersionDBTypes, false, strmangle.SetComplement(agentVersionPrimaryKeyColumns, agentVersionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = a.SetAgentVersion(ctx, tx, true, &b); err != nil {
		t.Fatal(err)
	}

	if err = a.RemoveAgentVersion(ctx, tx, &b); err != nil {
		t.Error("failed to remove relationship")
	}

	count, err := a.AgentVersion().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 0 {
		t.Error("want no relationships remaining")
	}

	if a.R.AgentVersion != nil {
		t.Error("R struct entry should be nil")
	}

	if !queries.IsValuerNil(a.AgentVersionID) {
		t.Error("foreign key value should be nil")
	}

	if len(b.R.Visits) != 0 {
		t.Error("failed to remove a from b's relationships")
	}
}

func testVisitToOneSetOpCrawlUsingCrawl(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c Crawl

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, crawlDBTypes, false, strmangle.SetComplement(crawlPrimaryKeyColumns, crawlColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, crawlDBTypes, false, strmangle.SetComplement(crawlPrimaryKeyColumns, crawlColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Crawl{&b, &c} {
		err = a.SetCrawl(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Crawl != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if !queries.Equal(a.CrawlID, x.ID) {
			t.Error("foreign key was wrong value", a.CrawlID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.CrawlID))
		reflect.Indirect(reflect.ValueOf(&a.CrawlID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if !queries.Equal(a.CrawlID, x.ID) {
			t.Error("foreign key was wrong value", a.CrawlID, x.ID)
		}
	}
}

func testVisitToOneRemoveOpCrawlUsingCrawl(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b Crawl

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, crawlDBTypes, false, strmangle.SetComplement(crawlPrimaryKeyColumns, crawlColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = a.SetCrawl(ctx, tx, true, &b); err != nil {
		t.Fatal(err)
	}

	if err = a.RemoveCrawl(ctx, tx, &b); err != nil {
		t.Error("failed to remove relationship")
	}

	count, err := a.Crawl().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 0 {
		t.Error("want no relationships remaining")
	}

	if a.R.Crawl != nil {
		t.Error("R struct entry should be nil")
	}

	if !queries.IsValuerNil(a.CrawlID) {
		t.Error("foreign key value should be nil")
	}

	if len(b.R.Visits) != 0 {
		t.Error("failed to remove a from b's relationships")
	}
}

func testVisitToOneSetOpMultiAddressesSetUsingMultiAddressesSet(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c MultiAddressesSet

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, multiAddressesSetDBTypes, false, strmangle.SetComplement(multiAddressesSetPrimaryKeyColumns, multiAddressesSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, multiAddressesSetDBTypes, false, strmangle.SetComplement(multiAddressesSetPrimaryKeyColumns, multiAddressesSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*MultiAddressesSet{&b, &c} {
		err = a.SetMultiAddressesSet(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.MultiAddressesSet != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if !queries.Equal(a.MultiAddressesSetID, x.ID) {
			t.Error("foreign key was wrong value", a.MultiAddressesSetID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.MultiAddressesSetID))
		reflect.Indirect(reflect.ValueOf(&a.MultiAddressesSetID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if !queries.Equal(a.MultiAddressesSetID, x.ID) {
			t.Error("foreign key was wrong value", a.MultiAddressesSetID, x.ID)
		}
	}
}

func testVisitToOneRemoveOpMultiAddressesSetUsingMultiAddressesSet(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b MultiAddressesSet

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, multiAddressesSetDBTypes, false, strmangle.SetComplement(multiAddressesSetPrimaryKeyColumns, multiAddressesSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = a.SetMultiAddressesSet(ctx, tx, true, &b); err != nil {
		t.Fatal(err)
	}

	if err = a.RemoveMultiAddressesSet(ctx, tx, &b); err != nil {
		t.Error("failed to remove relationship")
	}

	count, err := a.MultiAddressesSet().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 0 {
		t.Error("want no relationships remaining")
	}

	if a.R.MultiAddressesSet != nil {
		t.Error("R struct entry should be nil")
	}

	if !queries.IsValuerNil(a.MultiAddressesSetID) {
		t.Error("foreign key value should be nil")
	}

	if len(b.R.Visits) != 0 {
		t.Error("failed to remove a from b's relationships")
	}
}

func testVisitToOneSetOpPeerUsingPeer(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c Peer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, peerDBTypes, false, strmangle.SetComplement(peerPrimaryKeyColumns, peerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, peerDBTypes, false, strmangle.SetComplement(peerPrimaryKeyColumns, peerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Peer{&b, &c} {
		err = a.SetPeer(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Peer != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.PeerID != x.ID {
			t.Error("foreign key was wrong value", a.PeerID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.PeerID))
		reflect.Indirect(reflect.ValueOf(&a.PeerID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.PeerID != x.ID {
			t.Error("foreign key was wrong value", a.PeerID, x.ID)
		}
	}
}
func testVisitToOneSetOpProtocolsSetUsingProtocolsSet(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c ProtocolsSet

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*ProtocolsSet{&b, &c} {
		err = a.SetProtocolsSet(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.ProtocolsSet != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if !queries.Equal(a.ProtocolsSetID, x.ID) {
			t.Error("foreign key was wrong value", a.ProtocolsSetID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.ProtocolsSetID))
		reflect.Indirect(reflect.ValueOf(&a.ProtocolsSetID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if !queries.Equal(a.ProtocolsSetID, x.ID) {
			t.Error("foreign key was wrong value", a.ProtocolsSetID, x.ID)
		}
	}
}

func testVisitToOneRemoveOpProtocolsSetUsingProtocolsSet(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b ProtocolsSet

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = a.SetProtocolsSet(ctx, tx, true, &b); err != nil {
		t.Fatal(err)
	}

	if err = a.RemoveProtocolsSet(ctx, tx, &b); err != nil {
		t.Error("failed to remove relationship")
	}

	count, err := a.ProtocolsSet().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 0 {
		t.Error("want no relationships remaining")
	}

	if a.R.ProtocolsSet != nil {
		t.Error("R struct entry should be nil")
	}

	if !queries.IsValuerNil(a.ProtocolsSetID) {
		t.Error("foreign key value should be nil")
	}

	if len(b.R.Visits) != 0 {
		t.Error("failed to remove a from b's relationships")
	}
}

func testVisitToOneSetOpSessionUsingSession(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b, c Session

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, sessionDBTypes, false, strmangle.SetComplement(sessionPrimaryKeyColumns, sessionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, sessionDBTypes, false, strmangle.SetComplement(sessionPrimaryKeyColumns, sessionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Session{&b, &c} {
		err = a.SetSession(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Session != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Visits[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if !queries.Equal(a.SessionID, x.ID) {
			t.Error("foreign key was wrong value", a.SessionID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.SessionID))
		reflect.Indirect(reflect.ValueOf(&a.SessionID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if !queries.Equal(a.SessionID, x.ID) {
			t.Error("foreign key was wrong value", a.SessionID, x.ID)
		}
	}
}

func testVisitToOneRemoveOpSessionUsingSession(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Visit
	var b Session

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, sessionDBTypes, false, strmangle.SetComplement(sessionPrimaryKeyColumns, sessionColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = a.SetSession(ctx, tx, true, &b); err != nil {
		t.Fatal(err)
	}

	if err = a.RemoveSession(ctx, tx, &b); err != nil {
		t.Error("failed to remove relationship")
	}

	count, err := a.Session().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 0 {
		t.Error("want no relationships remaining")
	}

	if a.R.Session != nil {
		t.Error("R struct entry should be nil")
	}

	if !queries.IsValuerNil(a.SessionID) {
		t.Error("foreign key value should be nil")
	}

	if len(b.R.Visits) != 0 {
		t.Error("failed to remove a from b's relationships")
	}
}

func testVisitsReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testVisitsReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := VisitSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testVisitsSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Visits().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	visitDBTypes = map[string]string{`ID`: `integer`, `PeerID`: `integer`, `CrawlID`: `integer`, `SessionID`: `integer`, `DialDuration`: `interval`, `ConnectDuration`: `interval`, `CrawlDuration`: `interval`, `VisitStartedAt`: `timestamp with time zone`, `VisitEndedAt`: `timestamp with time zone`, `UpdatedAt`: `timestamp with time zone`, `CreatedAt`: `timestamp with time zone`, `Type`: `enum.visit_type('crawl','dial')`, `Error`: `enum.dial_error('io_timeout','connection_refused','protocol_not_supported','peer_id_mismatch','no_route_to_host','network_unreachable','no_good_addresses','context_deadline_exceeded','no_public_ip','max_dial_attempts_exceeded','unknown','maddr_reset','stream_reset','host_is_down','negotiate_security_protocol_no_trailing_new_line')`, `ProtocolsSetID`: `integer`, `AgentVersionID`: `integer`, `MultiAddressesSetID`: `integer`}
	_            = bytes.MinRead
)

func testVisitsUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(visitPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(visitAllColumns) == len(visitPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, visitDBTypes, true, visitPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testVisitsSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(visitAllColumns) == len(visitPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Visit{}
	if err = randomize.Struct(seed, o, visitDBTypes, true, visitColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, visitDBTypes, true, visitPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(visitAllColumns, visitPrimaryKeyColumns) {
		fields = visitAllColumns
	} else {
		fields = strmangle.SetComplement(
			visitAllColumns,
			visitPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := VisitSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testVisitsUpsert(t *testing.T) {
	t.Parallel()

	if len(visitAllColumns) == len(visitPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := Visit{}
	if err = randomize.Struct(seed, &o, visitDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Visit: %s", err)
	}

	count, err := Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, visitDBTypes, false, visitPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Visit struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Visit: %s", err)
	}

	count, err = Visits().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
